#!/bin/bash
###############################################################################
#
#  Title: 	PingGenerator.sh
#  Author: 	Tony Bowles
#  Date:	Feb. 23, 2010
#  Description:	Read a list of host from input file and ping each host several
#		times to keep VPN connections open.  This script is designed
#		to be ran by crontab every 5 minutes.
#
###############################################################################


FIN="PingGenerator_input.txt"
OUTFILE="/tmp/PingGenerator.$$.out"
DEBUG="TRUE"
PIDFILE="/var/run/PingGenerator.pid"

if [ -e "$PIDFILE" ] ; then
	echo -e "\n\n\tWARNING: Another instance running having PID of `cat $PIDFILE` \n\n"
	exit
else
	echo "$$" > $PIDFILE
fi


for h in `cat $FIN`
do
	ping -c 4 $h >> $OUTFILE
	rc="$?"
	if [ "$rc" != "0" ] ; then
		echo -e "\n\n\tERROR: Ping of $h returned: $rc\n\n"
	fi
	if [ "$DEBUG" = "TRUE" ] ; then
		cat $OUTFILE
	fi
done

rm -f $PIDFILE
