#! /bin/bash


startdate=$1
stopdate=$2

[ "verify" == "$3" ] && verify="-v"

# currentdate.state will contain the last starting date that was queried for
# At the completion of batchretrieve.sh run it will be decremented
# We use it to keep track of what day was done last in case the script is interrupted for some reason.

if [ -f currentdate.state ]; then
    read -p "Resume from last successful date? Y/n: " ans
    if [ "$ans" = "Y" -o "$ans" = "y" ]; then 
        . currentdate.state
    else
        rm -f currentdate.state
    fi
fi

[ -z "$currentdate" ] && currentdate=$startdate

#### NOTES
# date --date="20100610 1 day ago" +%Y%m%d
# returns 20100609

# date --date="20100610 1 day" +%Y%m%d
# returns 20100611
#################

while [ ${currentdate} -ge ${stopdate} ]; do
    echo "currentdate=$currentdate" > currentdate.state
    querydate="${currentdate}-${currentdate}"
    echo "./batchretrieve.sh -d $querydate"
    ./batchretrieve.sh -d $querydate $verify
    if [ $? -ne 0 ]; then
        echo "batchretrieve.sh returned an error, stopping"
        break
    fi
    nextdate=$(date --date="$currentdate 1 day ago" +%Y%m%d)
    currentdate=$nextdate
done
