#!/bin/bash


# Input will look like: /home/medsrv/data/dicom.repository/data3/DHA/1.2.840.113745.101000.1156001.39417.7194.2407911

[ -z "$1" ] && echo "ERROR: Missing parameter, full path to source directory" && exit 1

CompletedList="RemovedbycheckMigrated.list"
sty=`basename $1`
sdir="$1"

alreadyChecked=`grep $1 $CompletedList`
[ ! -z "$alreadyChecked" ] && echo "$1 Already Checked." && exit


ddir=`$HOME/component/repositoryhandler/scripts/locateStudy.sh -d $sty`

scount=`ls $sdir | wc -l`
dcount=`ls $ddir | wc -l`

if [ $scount -eq $dcount ] ; then
	echo "Same number of objects: $scount Removing $sdir"
	echo "rm -rf $sdir"
	rm -rf $sdir
	rc=$?
	[ $rc -eq 0 ] && echo "$sdir" >> $CompletedList
elif [ $scount -lt $dcount ] ; then
	echo "More objects ($dcount) in dicom dir, $ddir, that in ($scount) source dir, $sdir. OK, Removing..."
	echo "rm -rf $sdir"
	rm -rf $sdir
	rc=$?
	[ $rc -eq 0 ] && echo "$sdir" >> $CompletedList
elif [ $scount -gt $dcount ] ; then
	echo "More objects ($scount) in source dir, $sdir, that in ($dcount) dicom dir, $ddir"
fi

