#! /bin/bash
. ~/etc/setenv.sh

inputlist=$1

cOper="change"
mkpasswdargs=" -l 10 -s 0"
# -l length -C min_upper -c min_lower -s min_special -d min_digits
# min_digits, min_upper, and min_lower are 2 if unspecified

outputfile="$0.$(hostname -f)"

if ! mkpasswdbin=$(which mkpasswd); then
    echo "Missing mkpasswd."
    echo "As root, issue 'yum -y install expect'"
    echo "and then run this program again."
    exit 1
fi


# Check/configure rights in access.cfg
# Must have the following configured in var/iface/access.cfg:
# 127.0.0.1="A"
if [ -f $HOME/var/iface/access.cfg ]; then
    localhostrights=$(grep 127.0.0.1 $HOME/var/iface/access.cfg)
    if [ -z "$localhostrights" ]; then
        echo "127.0.0.1=\"A\"" >> $HOME/var/iface/access.cfg
    else
        hasA=$(echo ${localhostrights%%*A*})
        if [ ! -z "$hasA" ]; then # if hasA is empty, it means A was present in the string.  Wierd, I know
            cat $HOME/var/iface/access.cfg | sed '/127.0.0.1/d' > $HOME/var/iface/access.cfg.temp
            newlocalhostrights=$(echo $localhostrights | sed 's/"$/A"/' )
            echo "$newlocalhostrights" >> $HOME/var/iface/access.cfg.temp
            cp -va $HOME/var/iface/access.cfg $HOME/var/iface/access.cfg.orig
            mv $HOME/var/iface/access.cfg.temp $HOME/var/iface/access.cfg
        fi
    fi
else
    echo "127.0.0.1=\"A\"" > $HOME/var/iface/access.cfg
fi

if [ -f "$outputfile" ]; then
    mv $outputfile $outputfile.$(date +%s)
else
    > $outputfile
    chmod 600 $outputfile
fi 

cat $1 | while read c_ID; do

    isuser=$(sql.sh "select ID from Access where ID = '$c_ID';" -N)
    if [ -z "$isuser" ]; then
        echo "User $c_ID doesn't exist"
        continue
    fi

    c_PASSWD=$($mkpasswdbin $mkpasswdargs)

    #echo "$c_ID,$c_PASSWD" | tee -a $outputfile
    echo "$c_ID,$c_PASSWD" >> $outputfile
    #echo Calling curl: curl "http://127.0.0.1/iface/userOper.jsp?cOper=$cOper&c_ID=$c_ID&c_PASSWD=$c_PASSWD"

    curl "http://127.0.0.1/iface/userOper.jsp?cOper=$cOper&c_ID=$c_ID&c_PASSWD=$c_PASSWD"
    retval=$?
    echo "curl returns: $retval"
    if [ $retval -ne 0 ]; then
        echo "curl returned an error. exiting"
        exit 1
    else
        echo "Password successfully changed for $c_ID"
    fi
done

echo "Password file is $outputfile, be sure to delete it when you have copied it off."
