#! /bin/bash
# ex: set expandtab shiftwidth=4 softtabstop=4 syntax=sh:

. /home/medsrv/etc/setenv.sh
. servercleanup.shi
. /home/medsrv/var/conf/serverid.cfg

styiuid=$1
myparent=$(getParent)
[ -z "$styiuid" ] && exit
echo "On $SELF_SERVER_ID"

# Notes:
#   1./
#       ~/component/utils/bin/storestate.sh -S <study> --archive=<archiveDevice>
#   2./
#      ~/component/cases/setStudyAttribute.sh -s <study> -H <cwl server> 

if isOrder $styiuid; then
    echo "$styiuid : order - skipping"
    exit
else
    echo "$styiuid : not an order"
fi

if has0Objs $styiuid; then
    echo "$styiuid : No objects - skipping"
    exit
else
    echo "$styiuid : has objects"
fi

echo "Checking ArchiveDevice"
fixArchiveDevice $styiuid $SELF_SERVER_ID $myparent
if [ $? -ne 0 ]; then
    echo "$styiuid : Can't fix ArchiveDevice, skipping"
    exit
fi

echo "Checking $styiuid on Archive"
archdir=$(getLocalArchDir $styiuid)
if [ -z "$archdir" ]; then
    echo "$styiuid : Not on archive, reindexing"
    /home/medsrv/component/cases/reindexStudy.sh -r $styiuid       
else
    for ofile in $(ls -1 $DICOM_DATA/$styiuid/); do
        if ! ls /home/medsrv/var/archive/${archdir}/${styiuid}/${ofile} > /dev/null 2>&1; then
            echo "$styiuid : Missing $ofile on archive, reindexing"
            /home/medsrv/component/cases/reindexStudy.sh -r $styiuid
            break
        else
            echo "$styiuid : $ofile : OK on Archive"
        fi
    done
fi
    
