#! /bin/bash
# ArchiveDevice="@Archive-dhs-c3"

. /home/medsrv/etc/setenv.sh

MYSQL=$MYSQL_HOME/bin/mysql
DB=imagemedical
archivedev="@Archive-$(hostname -s)"

function getParent() {
    # echoes this server's parent

    res=$(echo "select ID from Target where type = 'P';" | \
        $MYSQL -N $DB)
    echo $res
} # End of getParent()

function fixStudy() {
	local styiuid=$1
	local arch=$2
	local parent=$3

	~/component/utils/bin/storestate.sh -S $styiuid --archive=$arch
	[ $? -ne 0 ] && echo "Failed storestate" && exit 1
	~/component/cases/setStudyAttribute.sh -s $styiuid -H $parent
	[ $? -ne 0 ] && echo "Failed setStudyAttribute" && exit 1
	~/component/cases/reindexStudy.sh -r $styiuid
	[ $? -ne 0 ] && echo "Failed reindexStudy" && exit 1
}

myparent=$(getParent)

if [ -z "$1" ]; then
	cat $(hostname -s).archivedevice.ls| awk '{print $1}' |while read s; do
		echo $s
		fixStudy $s $archivedev $myparent
	done
else
	fixStudy $1 $archivedev $myparent
fi


