#!/bin/bash

# backup and change the Input Field Separator to a newline
OIFS="$IFS"
IFS="
"


BUDIR="/home/medsrv/work/origreporttemplates"
LISTFILE="trailSpaces.list"
INFOFILE="$BUDIR/TemplateInfo"

# Build the list of report templates that have trailing spaces...
find /home/medsrv/data/users/ -name "* .tmplt" > $LISTFILE

for t in `cat $LISTFILE `
do
    # make backup of original template
    cp "$t" $BUDIR/
    echo "cp \"$t\" $BUDIR/" >> $INFOFILE
    dname=`dirname "$t"`
    oname=`basename "$t"`
    nname=`echo $oname | sed -e 's/ .tmplt/.tmplt/'`
    echo "oname = $oname nname = $nname dname = $dname"
    mv "$t" "$dname/$nname"
    echo "mv \"$t\" \"$dname/$nname\"" >> $INFOFILE
    echo -e "\n\n"
done

# Restore Input field separator to it's original value
IFS="$OIFS"
