#!/bin/bash

mday[1]="1 31"
mday[2]="1 28"
mday[3]="1 31"
mday[4]="1 30"
mday[5]="1 31"
mday[6]="1 30"
mday[7]="1 31"
mday[8]="1 31"
mday[9]="1 30"
mday[10]="1 31"
mday[11]="1 30"
mday[12]="1 31"

WDIR=$(dirname $0)
CUSTOMERSFILE="$WDIR/customers"
RECPT="labida@erad.com, tbowles@erad.com, rphillips@erad.com, gvladmin@erad.com, criley@erad.com"
#RECPT="tbowles@erad.com"
MAIL="/usr/sbin/sendmail"
netadminemail="admin@erad.com"

MAILFILESTART="Subject: DR usage for ASP Customers on $(hostname).\nFrom: $(hostname)\n\n\
This email is to inform you of the DR usage for our ASP customers.  Please visit the links listed below to download the CSV, Comma Separated Value, file for each customer.\n"

MAILFILEEND="\n\nAny questions should be sent to $netadminemail.  Thank you."



rawMonth=$(date +%-m --date="last month")
year=$(date +%-Y --date="last month")
thisMonth=$(printf %02d $rawMonth)
DB="/home/medsrv/component/mysql/bin/mysql imagemedical"

if [ ! -e "${WDIR}/${year}-$thisMonth" ] ; then
	mkdir ${WDIR}/${year}-$thisMonth
fi

for CUSTOMER in $(cat $CUSTOMERSFILE)
do
	echo ${mday[$rawMonth]} | while read s e
	do
		news=$(printf %02d $s)
		echo "select 
			PNAME as PatientName, 
			PID as PatientID, 
			ACCNO as AccessionNumber, 
			STR_TO_DATE(THEDATE, '%Y%m%d')  as StudyDate, 
			STR_TO_DATE(RCVDATE, '%Y%m%d') as ReceivedDate, 
			MODALITY,  
			CONCAT(FORMAT(SUMSIZE / 1024 , 2), 'K') as StudySize,  
			THERAD as Radiologist,
			STYDESCR as Description,
			INSTNAME as InstitutionName, 
			USER5 as CustomerCode, 
			STYIUID as StudyInstanceUID 
		from Dcstudy 
		where RCVDATE BETWEEN ${year}${thisMonth}${news} AND ${year}${thisMonth}${e} 
		AND USER5 like '%${CUSTOMER}%' 
		order by INSTNAME" | $DB | sed -e 's/,//g' | sed -e 's/\t/,/g' > $WDIR/${year}-$thisMonth/${year}-${thisMonth}-${CUSTOMER}.csv
	done
 	
done

rsync -va ${WDIR}/${year}-$thisMonth ~/htdocs/download/

for f in $(ls  ~/htdocs/download/${year}-$thisMonth/ )
do
	if [[ "$f" != "email" ]] ; then
		mailbody="$mailbody\nhttp://$(hostname)/download/${year}-$thisMonth/$f"
	fi
done

#  Send the mail
echo -e $MAILFILESTART $mailbody $MAILFILEEND | $MAIL -f "medsrv@$(hostname)" "$RECPT"

# Copy mail body to historical storage as a text file
echo -e $MAILFILESTART $mailbody $MAILFILEEND > ${WDIR}/${year}-${thisMonth}/email

