#!/bin/bash
#
#   NAME:       archivecheck.sh
#   AUTHOR:     Tony Bowles
#   DATE:       4/24/2006
#   

# BINARIES
AWK="/bin/awk"
BASENAME="/bin/basename"
CAT="/bin/cat"
FIND="/usr/bin/find"
ECHO="/bin/echo -e"
EGREP="/bin/egrep"
SED="/bin/sed"
TOUCH="/bin/touch"


# STATIC CONFIG
MEDHOME="/home/medsrv"
ARCHDIR="$MEDHOME/var/archive"
ARCHCFGDIR="$MEDHOME/var/arch"
ARCHCFGFILE="$ARCHCFGDIR/archive.cfg"
MYSQL="$MEDHOME/component/mysql/bin/mysql"
DB="imagemedical"
ARCTBL="Archive"
QRY="select DISTINCT ARCHDIR from Archive; "
QRY2="select ARCHDIR, STYIUID from Archive; "

# RUNTIME CONFIG
NUMARCPARTS=0
TMPFL="$MEDHOME/tmp/archivecheck.tmp.$$"
TMPFL3="$MEDHOME/tmp/archivecheck.tmp3.$$"


if [[ -e $ARCHCFGFILE ]] ; then
  #  We have a standard Archive configured
  $ECHO "Archive is present on this server"
#  CURMNTPT=`$CAT $ARCHCFGFILE | $EGREP "MountPoint" | $AWK -F= '{ print $2 }' | $SED -e 's/"//g'`
#  $ECHO "Current Mount Point is $CURMNTPT"
else
  $ECHO "Archive is NOT  present on this server, exiting..."
  exit
fi

STYDIRS=`$ECHO $QRY | $MYSQL $DB `

$TOUCH $TMPFL

$ECHO $STYDIRS | $EGREP  "^/" >> $TMPFL

if [[ -s $TMPFL ]] ; then
 # we have leading /'s in our archive table ARCHDIR entries
 LEADSLASH=true
fi

$ECHO $QRY2 | $MYSQL $DB > $TMPFL3
$ECHO " Finding empty files and listing them...\n"

while read DIR STYIUID
do
#  echo "DIR = $DIR  and STYIUID = $STYIUID"
  if [[ $LEADSLASH ]] ; then
    $FIND $ARCHDIR$DIR/$STYIUID -type f -empty -print 2>/dev/null
  else
    $FIND $ARCHDIR/$DIR/$STYIUID -type f -empty -print 2>/dev/null
  fi
done < $TMPFL3

$ECHO "\n DONE Finding empty files and listing them...\n"

