#!/bin/bash
#
# Author:       Tony Bowles
# Date:         March 7 2012
#
# First argument, $1, is the name of input file.  
# Secod argument, $2, is the name of the Dcstudy table field.
# Input file expects each line to contain the value of the field.  
# For example, if the field in $2 is INSTNAME then the input file
# shall contain 1 institution name per line.  Spaces are allowed in
# the input values within a line, but the first character of the 
# line shall not be a whitespace character.

function usage()
{
        echo -e "\n\tUsage: $0 <input file> <Dcstudy Field Name>"
        echo -e "\n\tExample: $0 myinst.list INSTNAME\n\n"
        exit 120
}

[ -z "$1" ] && usage

[ -z "$2" ] && usage

[ ! -e $1 ] && echo -e "\n\nERROR: Input file, $1 does not exist\n\n" && exit 121

DB="/home/medsrv/component/mysql/bin/mysql -N imagemedical"

validField=`echo "describe Dcstudy" | $DB | grep $2`

[ -z "$validField" ] && echo -e "\n\nERROR: $2 is not a valid field name in Dcstudy.  Run describe Dcstudy to find fields.\n" $$ exit 122

[ ! -d "./$2" ] && mkdir $2

OIFS="IFS"
IFS="
"
i=0
for value in `cat $1`
do
   echo "select STYIUID from Dcstudy where $2='$value'" | /home/medsrv/component/mysql/bin/mysql -N imagemedical > $2/$i.stys
   i=$((i+1))
done
IFS="$OIFS"

