#! /bin/bash

#sql.sh "select styiuid from Dcreport where iappdate > '20110708' order by iappdate;" -N| while read s; do sloc=$(~/component/repositoryhandler/bin/locateResource /home/medsrv/data/dicom.repository $s); echo $sloc; srt=$(ls -1 ${sloc}/SR*); echo $srt; ~/component/hl7/bin/createORUMessage.sh -V -D -s -S -m REPORT -e HL7_REPORT_APPROVED -S $s -f $srt; done

styiuid=$1
srt=$2

if [ -z "$1" ]; then
    echo "Usage:"
    echo "$0 styiuid [full/path/to/SRt]"
    echo "If you do not specify an SRt, the script will send all SRts in the repo for the study"
    exit 0
fi
 

sloc=$(~/component/repositoryhandler/bin/locateResource /home/medsrv/data/dicom.repository $styiuid)
echo "Study location: $sloc"

if [ -z "$srt" ]; then
# If we didn't specify an SRt, send them all
    srts="$(ls -1 ${sloc}/SR*)"
    for srt in $srts; do
        echo "SRt found: $srt"
        ~/component/hl7/bin/createORUMessage.sh -V -D -s -m REPORT -e HL7_REPORT_APPROVED -S $styiuid -f $srt
    done
else
    ~/component/hl7/bin/createORUMessage.sh -V -D -s -m REPORT -e HL7_REPORT_APPROVED -S $styiuid -f $srt
fi

