#!/bin/bash
#
#

. $HOME/etc/setenv.sh
WD="$HOME/work/mu"
FIN="$WD/monitorUsers.list"
LOG="$HOME/var/log/info.log"
MAIL="/usr/sbin/sendmail"
RECPT="support@proradsolutions.com"
HOST="images1.allianceimaging.com"
YESTERDAY=`date +%Y%m%d --date="yesterday"`
declare -a olfArray # old log file array - one element per line in the old log file
declare -a lfArray # log file array - one element per line in the log file



for user in `cat $FIN`
do
	uLog="$WD/$user.log.`date +%Y%m%d`"
	uOldLog="$WD/$user.log.old.`date +%Y%m%d`"

	olfndx=0 # old log file index
	if [ -e "$uLog" ] ; then
		mv $uLog $uOldLog
		while read line
		do
			olfArray[$olfndx]="$line"
			((olfndx++))
		done < $uOldLog
	fi
 	grep $user $LOG | grep ADMIN > $uLog

	lfndx=0
	while read line
	do
		lfArray[$lfndx]="$line"
		((lfndx++))	
	done < $uLog

	if [[ $lfndx -gt $olfndx ]] ; then
		echo "Subject: New Admin actions by $user on $HOST" > emailbody
		echo -e "From:medsrv@$(hostname)\n" >> emailbody
		echo -e "\n!!!Attention !!!\n\nNew Admin actions by $user on $HOST\n" >> emailbody
		echo -e "\n\n TO see the logs on the server visit: https://$HOST/imadmin/logs.jsp \n\n" >> emailbody
		actCnt=$((lfndx - olfndx))
		fstNewActndx=$((lfndx - actCnt))
		for i in `seq $fstNewActndx $lfndx`
		do
			echo ${lfArray[$i]} >> emailbody
		done
		cat emailbody | $MAIL $RECPT
#	else	
#		echo "No New actions by $user"
	fi

	#!!! testing !!!
	#echo "uLog = $uLog uOldLog = $uOldLog"
	#cat $uLog
done

# Cleanup

[ ! -e "$WD/old" ] && mkdir $WD/old
find $WD -maxdepth 1 -name "*$YESTERDAY*" -exec mv {} $WD/old \;
#find $WD -maxdepth 1 -name "*$yesterday*" -exec mv {} $WD/old \;
