#! /bin/bash

styiuid=$1
dest=$2
action=$3
# The action parameter is not meant to be used by the user

supportdevsql="INSERT INTO Target VALUES ('support_use_only','127.0.0.1','127.0.0.1',104,'SUPPORTONLY','','','D','T',0,0);"
supportdevsrvsql="INSERT INTO DevServ VALUES ('support_use_only','StrU');"

. ~/etc/setenv.sh
. criley_func.shi

[ ! -d ~/work ] && mkdir ~/work

# From criley_func.shi
children=$(getChildren)

[ -z "$styiuid" -o -z "$dest" ] && echo "$0 styiuid dest" && exit

if [ -n "$action" ]; then
    hassupportdevice=$(echo "select ID from Target where AE = 'SUPPORTONLY';" |\
                       ~/component/mysql/bin/mysql -N imagemedical)
    while [ -z "$hassupportdevice" ]; do
        echo "Adding the support device."
        echo $supportdevsql | $MYSQL $DB
        echo $supportdevsrvsql |$MYSQL $DB
        hassupportdevice=$(echo "select ID from Target where AE = 'SUPPORTONLY';" | \
                           ~/component/mysql/bin/mysql -N imagemedical)
	echo "Stopping dicom on $(hostname)"
        ~/component/dicom/ctrl stop
        pbscp_running=$(ps -ax|grep pb-sc[p])
        while [ -n "$pbscp_running" ]; do
            echo "Waiting for dicom to stop on $(hostname)"
            sleep 5
        done
        echo "Starting dicom on $(hostname)"
        ~/component/dicom/ctrl start
    done
    
    . ~/var/dicom/pb-scp.cfg

    cd ~/work/${styiuid}/
    ~/component/dicom/bin/storescu -v -R -aet SUPPORTONLY -aec $AE_TITLE 127.0.0.1 104 $(ls -1)
    if [ $? -ne 0 ]; then
        echo "$(hostname -s): Error Sending the study to myself."
    else
        echo "Study successfully sent - Now merge the studies on the worklist"
    fi
    exit
fi

studydir=$(~/component/tools/printStudyInfo.sh -s $styiuid -D|grep Study|awk '{print $3}')
echo "Syncing $styiuid to $dest.."
[ ! -d "${studydir}" ] && echo "No such study! Exiting due to PEBCAK!" && exit
rsync -va -e ssh ${studydir} ${dest}:/home/medsrv/work/ --copy-links

if [ $? -ne 0 ]; then
    echo "Error syncing to $dest .. aborting"
    exit 1
else
    if [ -n "$children" ]; then
        echo "Checking for study on my children.."
        for child in $children; do
            echo "Checking $child.."
            if isOnChild $styiuid $child ; then
                echo "exists on $child, removing.."
                removeStudyOnChild $styiuid $child
                # Should check to see if study is really removed here.  Or maybe in removeStudyOnChild
            else
                echo "Not on $child"
            fi
        done
    fi
    
    echo "Removing $styiuid from local server ($(hostname -s)).."
    ~/component/cases/rmstudy.sh $styiuid
    sleep 1
    echo "Obsoleting $styiuid from Archive .. "
    ~/component/archive/obs.sh $styiuid
    ssh $dest $0 $styiuid $dest send_to_self
fi


