#!/bin/bash
#
# resched.sh - Used to slowly moved studies from suspended to unscheduled queue
#            USAGE: resched.sh <queue>
#

function usage()
{
   echo -e "\n\n\tUSAGE:\n\t\t$0 [cpuqueue|netqueue]\n\n"
}

[ -z "$1" ] && usage && exit

[ ! -d $HOME/var/$1 ] && usage && exit

#  The number to move at one time
NUM=200

#  If there are more that $NUM tasks in the scheduled queue then sleep this many seconds
SLEEPNUM=60

#  What Queue are we working on {cpuqueue|netqueue}
#Q="netqueue"
Q="$1"

# This is the directory where the tasks have been moved to
SRCQ="$HOME/var/$Q/.suspended"

# This is the directory where we want to move the tasks to
DSTQ="$HOME/var/$Q/"


###########################################################################################
#
#  DO NOT EDIT BELOW HERE
#
###########################################################################################

TOTAL=`ls $SRCQ | wc -l`
i=0

TOMOVE=`ls $SRCQ | wc -l`
while [ "$TOMOVE" -gt 0 ]
do
   sleep 5 # it takes a few seconds for the taskmanager to move tasks to scheduled queue
   LOAD=`ls $HOME/var/$Q/.scheduled | wc -l`
   while [ "$LOAD" -gt "0" ] # Give the queue a chance to completely drain
   do
      echo -e "\tCurrent Tasks in $Q = $LOAD, current date is `date` , sleeping $SLEEPNUM seconds..."
      sleep $SLEEPNUM
      LOAD=`ls $HOME/var/$Q/.scheduled | wc -l`
   done
   echo "Moving $NUM of $TOTAL tasks to $DSTQ"
   i=0
   for t in `ls $SRCQ | head -n $NUM`
   do
     i=$((i+1))
     mv $SRCQ/$t $DSTQ/
     echo -e "\tC[ $i of $TOMOVE]: $t"
   done
   TOMOVE=`ls $SRCQ | wc -l`
done


